QGIS Application - Bug report #17187
Attribute Table refresh issue
2017-09-24 11:31 AM - Geo Dev

Status: Closed

Priority: High

Assignee: Luigi Pirelli

Category: Attribute table

Affected QGIS version:master Regression?: Yes
Operating System: Linux and Windows Easy fix?: Yes

Pull Request or Patch supplied: Resolution: duplicate
Crashes QGIS or corrupls data: Copied to github as #: 25086
Description

The Attribute Table doesn't immediately update when fields are set with the Quick Field Calculation Bar.

Steps to replicate the issue:

- Open the Attribute Table of any vector layer

- Start editing

- Select an existing field in the drop-down list of the Quick Field Calculation Bar

- Fill the textbox of the Bar with a value or an expression

- Click on Update All button: the table doesn't update

- Force the refresh of the table (e.g. clicking on cells or sorting the columns): the table updates

Same behavior with Update Selected and Update Filtered buttons.

The user has the perception that the Update buttons do not work (priority: High).

The issue already exists in 2.18.12 but doesn't exist in 2.14 (minor release regression).
The issue also occurs in QGIS 2.99.0-Master.

Related issues:

Related to QGIS Application - Bug report # 17280: When switch between filtere... Closed
Related to QGIS Application - Bug report # 17312: Attribute Table refresh iss... Closed
Related to QGIS Application - Bug report # 17262: Attribute table data entere... Closed
Duplicated by QGIS Application - Bug report # 17289: Issue editing layers Closed

2017-10-14
2017-10-21
2017-10-09
2017-10-16

Associated revisions

Revision 6d50b37c - 2017-10-19 06:43 PM - Paul Blottiere

Merge pull request #5403 from boundlessgeo/issue_17187_backportFrom3

[bugfix] Attribute table model not updated when a feature is changed. fixes #17280 #17187

History

#1 - 2017-09-25 12:15 PM - Giovanni Manghi
- Regression? changed from No to Yes

If it worked in 2.14 then is @ major issue as it is a regression in between two LTR releases.

#2 - 2017-09-26 11:31 AM - Alexandre Neto
| faced the same problem.

At least with selected features, | was also able to refresh the table of attributes by scrolling it vertically.

#3 - 2017-09-27 07:47 PM - Steve Lowman

| confirm this issue with shapefile layers. And, | confirm it updates when you touch the scroll bar - you don't have to actually move it.

Is it occurring with non-shapefile layers, too?

Also | am getting a similar but less consistent issue with manual edits to individual cell values in Table view. It just did this the first time | tried to manually

edit a cell, only displaying after | did the scroll, but after that | could not repeat the issue with a manual edit in the same layer. The issue is consistent with

the Field Calculation bar, though.

#4 - 2017-09-30 11:20 AM - Geo Dev

It's a general issue. Same unexpected behavior with all the vector data formats.

#5 - 2017-10-16 08:37 PM - Steve Lowman

I think #17280 is a duplicate.

Related to #17262, which also concerns data entry in attribute table 'table view'.

#6 - 2017-10-17 09:10 AM - Giovanni Manghi

See also #17289

#7 - 2017-10-17 09:16 AM - Jiirgen Fischer

- Related to Bug report #17289: Issue editing layers added

#8 - 2017-10-17 09:17 AM - Jiirgen Fischer
- Related to deleted (Bug report #17289: Issue editing layers)

#9 - 2017-10-17 09:17 AM - Jiirgen Fischer
- Duplicated by Bug report #17289: Issue editing layers added

#10 - 2017-10-17 09:18 AM - Jiirgen Fischer
- Related to Bug report #17280: When switch between filtered modes, the edited cells stop updating themselves. added

#11 - 2017-10-17 10:59 AM - Steve Lowman

- File Bug_17187_Feature1.mp4 added

Added video demonstrating data entry in layer with one feature, showing data fails to display until Save is clicked.

#12 - 2017-10-17 11:01 AM - Steve Lowman
- File Bug_17187_Feature2.mp4 added

Added video demonstrating data entry in layer with two features, showing data displaying two cells behind data entry and failure to display calculated data

until Save is clicked.

#13 - 2017-10-18 03:33 PM - Luigi Pirelli

seems a side effect of my fix to avoid sorting during editing.

commit:6c84b6ead5e02ba71506fdbc6f5a24800c56b1dc

now checking how to update data without sorting in the new atteribute table architecture.

#14 - 2017-10-18 03:33 PM - Luigi Pirelli

- Assignee set to Luigi Pirelli

#15 - 2017-10-19 12:01 PM - Luigi Pirelli

the same issue was already fixed 4month ago in master commit:5f22ba1c936db18f9326b84315be03b4874282e0 but never backported

I'l do it.

#16 - 2017-10-19 12:09 PM - Giovanni Manghi

Luigi Pirelli wrote:

the same issue was already fixed 4month ago in master commit:5f22ba1c936db18f9326b84315be03b4874282e0 but never backported

I'll do it.

| assume this would also fix #17280 ?

#17 - 2017-10-19 12:27 PM - Luigi Pirelli
- Pull Request or Patch supplied changed from No to Yes
- Easy fix? changed from No to Yes

https://github.com/qgis/QGIS/pull/5403

#18 - 2017-10-19 04:22 PM - Luigi Pirelli
- Pull Request or Patch supplied changed from Yes to No

check if https:/github.com/qgis/QGIS/pull/5403 really fix the issue
#19 - 2017-10-19 05:51 PM - Luigi Pirelli
- Pull Request or Patch supplied changed from No to Yes

confirmed that https://github.com/qgis/QGIS/pull/5403 fix this issue

#20 - 2017-10-19 06:43 PM - Paul Blottiere
- Status changed from Open to Closed
- % Done changed from 0 to 100

Applied in changeset commit:qgis|6d50b37c628e858760a9bdea3fa3860826281134.

#21 - 2017-10-19 08:13 PM - Geo Dev

- Status changed from Closed to Reopened

The backported fix commit:5f22ba1c936db18f9326b84315be03b4874282e0
doesn't fix this issue (#17187) that still occurs also in QGIS 2.99.0-Master.

Steps to replicate the issue:

- Open the Attribute Table of any vector layer

- Start editing

- Select an existing field in the drop-down list of the Quick Field Calculation Bar

- Fill the textbox of the Bar with a value or an expression

- Click on Update All button: the table doesn't update

- Force the refresh of the table (e.qg. clicking on cells or sorting the columns): the table updates

#22 - 2017-10-20 09:44 AM - Giovanni Manghi
- Affected QGIS version changed from 2.18.13 to master

- Status changed from Reopened to Feedback

Geo Dev wrote:

The backported fix commit:5f22ba1c936db18f9326b84315be03b4874282¢0
doesn't fix this issue (#17187) that still occurs also in QGIS 2.99.0-Master.

Steps to replicate the issue:

- Open the Attribute Table of any vector layer

- Start editing

- Select an existing field in the drop-down list of the Quick Field Calculation Bar

- Fill the textbox of the Bar with a value or an expression

- Click on Update All button: the table doesn't update

- Force the refresh of the table (e.g. clicking on cells or sorting the columns): the table updates

| just checked and indeed the behavior is little different in master:
actually you don't need to force the refresh with the refresh button after using the calculator, you just need to change the focus away from the "update”
button. The problem of values not showing after entering them manually (and moving to a different cell with the "tab" key) is definitely solved also in
master. For sake of clarity | would suggest to file this in a different ticket, agree?

#23 - 2017-10-20 10:10 AM - Luigi Pirelli

yes, IMHO is better to close this issue and reopen one related to master. The main reason is also because, in this moment I'm more focused on 2.18
stability than master.
Is it ok for you Geo Dev?

#24 - 2017-10-20 04:31 PM - Geo Dev
IMHO the description of this bug (#17187) is properly focused on the issue that still occurs in both versions 2.18.13 and 2.99.0-Master (the Attribute Table
doesn't immediately update when fields are set with the Quick Field Calculation Bar).
The two attached videos should instead be removed since they don't explain the issue described in this report. They show a different issue (values not
showing after entering them manually) correctly explained into another bug report (#17289) but incorrectly indicated as duplicate of this one.
Furthermore this issue occurs exactly in the same way in both versions:
-in 2.18.13, exactly as in 2.99.0-Master, "you don't need to force the refresh with the refresh button after using the calculator" (even because in editing
mode the refresh button "reload table" is disabled). It's enough to refresh the table e.g. clicking on cells, sorting/resizing the columns, scrolling the table,
resizing the window container of the table, etc.;
- in 2.99.0-Master, exactly as in 2.18.13, it's not always enough "to change the focus away from the update button". Just after clicking on Update All button,
even if you change the focus e.g. changing the selected field in the drop-down list, turning on/off the layers in the TOC, click on the Zoom to Selected
button, etc. the table doesn't update anyway.
No problem to reopen another ticket for 2.99.0-Master but IMHO it would be exactly the same bug report with the same description.
Another solution might be to extend the title in "Attribute Table refresh issue using the Quick Field Calculation Bar".
In both cases the references to (#17289) should be removed to avoid confusion.
Let me know.
#25 - 2017-10-20 04:46 PM - Giovanni Manghi
Geo Dev wrote:

IMHO the description of this bug (#17187) is properly focused on the issue that still occurs in both versions 2.18.13 and 2.99.0-Master (the Attribute

Table doesn't immediately update when fields are set with the Quick Field Calculation Bar).

with the patch this is fixed in 2.18... not 2.18.13, you will have to wait 2.18.14 to test if you don't want to compile by yourself.

#26 - 2017-10-20 04:58 PM - Luigi Pirelli

or 2.18-dev

#27 - 2017-10-20 05:41 PM - sand thorn

| can not find 2.18-dev in

http://qgis.org/downloads/weekly/?C=M;0=D
There are only 2.99-dev. Besides, there seems no updates this week.

Where can | download pre-compiled developer version of current release?

#28 - 2017-10-20 06:18 PM - Giovanni Manghi

sand thorn wrote:

I can not find 2.18-dev in

http://qqgis.org/downloads/weekly/?C=M;O=D

There are only 2.99-dev. Besides, there seems no updates this week.

Where can | download pre-compiled developer version of current release?

use the osgeodw installer, follow the "advanced install" and install the package qgis-rel-dev

#29 - 2017-10-20 07:23 PM - Geo Dev

Tested on a just compiled code of the last 2.18-dev (with the latest commit 6d50b37) and on the already compiled OSGeo4W qgis-rel-dev 2.18.13-20
(QGIS code revision 6d50b37c62).
It's confirmed that the patch https://github.com/qgis/QGIS/pull/5403 doesn't fix this specific issue (#17187) in QGIS 2.18.

#30 - 2017-10-20 08:12 PM - Giovanni Manghi
Geo Dev wrote:
Tested on a just compiled code of the last 2.18-dev (with the latest commit 6d50b37) and on the already compiled OSGeo4W qgis-rel-dev

2.18.13-20 (QGIS code revision 6d50b37¢c62).
It's confirmed that the patch https.//github.com/qqis/QGIS/pull/5403 doesn't fix this specific issue (#17187) in QGIS 2.18.

just checked also on Windows here: also on 2.18-dev after updating with the quick calculator is needed to change the focus away from the button. This
means that there is a difference between Linux (where with the patch there is no need to change the focus after pressing the button) and Windows.
Regardless, as already said is better to file a new ticket... also because the patch is already committed and other problems referred here and in its twin
ticket are solved.

#31 - 2017-10-21 11:44 AM - Geo Dev

Tested 2.18-dev (just compiled) also on Linux:: exactly the same issue of Windows (even with regard to focus behaviour).
Ticket reopened as #17312 to avoid confusion since:
- the patch https://github.com/qgis/QGIS/pull/5403 doesn't fix this specific issue (#17187) but the #17289 incorrectly indicated as duplicate of this one;

- the two attached videos don't explain the issue described in this report but the #17289 bug.

#32 - 2017-10-21 02:31 PM - Steve Lowman
| agree - #17289 was a different bug.

The only reason | copied the videos over was because #17289 was incorrectly closed as a duplicate of #17187. As Geo Dev has observed, #17289 has

now been resolved, but #17187 has not.

However, we now have duplicates in #17187 and #17312, so one of these should be closed.

#33 - 2017-10-21 06:58 PM - Geo Dev

Yes, this bug report should now be closed with a reference to the new one (#17312).

#34 - 2017-10-23 10:08 AM - Giovanni Manghi

- Status changed from Feedback to Closed
- Resolution set to duplicate

replaced by #17312

#35 - 2017-10-23 10:17 AM - Jiirgen Fischer
- Related to Bug report #17312: Attribute Table refresh issue using the Quick Field Calculation Bar added

#36 - 2017-11-23 09:15 AM - Alessandro Pasotti
- Related to Bug report #17262: Attribute table data entered text is obscured by the 'x' button added

Files

Bug_17187_Feature1.mp4 3.01 MB 2017-10-17 Steve Lowman

Bug_17187_Feature2.mp4 2.69 MB 2017-10-17 Steve Lowman
